﻿function cargarEstados(ddlEstados) {
    var langArray = [
    { value: "1", text: "Activo" },
    { value: "0", text: "Inactivo" }
    ];

    //var select = document.createElement('select'),
    var option; i = 0; il = langArray.length;
    for (; i < il; i += 1) {
        option = document.createElement('option');
        option.setAttribute('value', langArray[i].value);
        option.appendChild(document.createTextNode(langArray[i].text));
        ddlEstados.appendChild(option);
    }
}

function mostrarMensaje(mensaje) { $('#modalConfirmacion').modal('show'); $('#lblMensaje').text(mensaje); }

function cargarTipoCiclo(ddlTipoCiclo) {
    $.ajax({
        type: "POST",
        contentType: "application/json; charset=utf-8",
        url: "../ServicioValidaciones.asmx/listarTipoCicloPresupuesto",
        data: "{}",
        dataType: "json",
        async: false,
        success: function (Result) {
            var resp = JSON.parse(Result.d);
            $.each(resp, function (key, value) {
                $(ddlTipoCiclo).append($("<option></option>").val
                (value.idPresupuestoTipoCiclo).html(value.nombre));
            });
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message + " método cargarTipoCiclo()");
        }
    });
}

function cargarPeriodoTipoCiclo(ddlPeriodoTipoCiclo, valorTipoCiclo) {
    var idPeriodoBasePresupuesto = -1;
    $.ajax({
        type: "POST",
        contentType: "application/json; charset=utf-8",
        url: "../ServicioValidaciones.asmx/listarPeriodosTipoCicloPresupuesto",
        data: "{idPeriodoBasePresupuesto:'" + idPeriodoBasePresupuesto + "', idTipoCicloPresupuesto:'" + valorTipoCiclo + "'}",
        dataType: "json",
        async: false,
        success: function (Result) {
            var resp = JSON.parse(Result.d);
            if (resp != "") {
                $(ddlPeriodoTipoCiclo).empty();
                $.each(resp, function (key, value) {
                    $(ddlPeriodoTipoCiclo).append($("<option></option>").val
                    (value.idPresupuestoPeriodoBase).html(value.nombre));
                });
            } else {
                $(ddlPeriodoTipoCiclo).empty();
            }
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message + " método cargarPeriodoTipoCiclo()");
        }
    });
}


function contarPeriodosAnio(anio) {
    var periodos = "";
    var campoAnio = document.getElementById(anio);
    var valorAnio = campoAnio.value;
    if (isNumeric(valorAnio) == true) {
        $.ajax({
            type: "POST",
            contentType: "application/json; charset=utf-8",
            url: "../ServicioValidaciones.asmx/ContarPeriodosAnio",
            data: "{anio:'" + valorAnio + "'}",
            dataType: "json",
            async: false,
            success: function (Result) {
                var resp = Result.d;
                if (resp > 0) {
                    periodos = "No";
                    alert("El año " + valorAnio + " ya tiene períodos asignados")
                    campoAnio.value = "";
                    campoAnio.focus();
                }
            },
            error: function (e) {
                periodos = "No";
                alert(JSON.parse(e.responseText).Message);
            }
        });
    } else {
        periodos = "No";
        alert("El año debe ser un valor numérico")
        campoAnio.value = "";
        campoAnio.focus();
    }
    return periodos;
}

function contarPeriodosActivosAnio(campoAnio) {
    var respuesta = 0;
    var valorAnio = campoAnio.value;
    if (isNumeric(valorAnio) == true) {
        $.ajax({
            type: "POST",
            contentType: "application/json; charset=utf-8",
            url: "../ServicioValidaciones.asmx/ContarPeriodosActivosAnio",
            data: "{anio:'" + valorAnio + "'}",
            dataType: "json",
            async: false,
            success: function (Result) {
                var resp = Result.d;
                if (resp > 0) {
                    respuesta = resp;
                }
            },
            error: function (e) {
                alert(JSON.parse(e.responseText).Message);
            }
        });
    } else {
        alert("El año debe ser un valor numérico")
    }
    return respuesta;
}

function generarPeriodosPresupuesto(campoAnio, campoTipoCiclo, campoPeriodoInicio, campoFechaInicio, gvsPeriodos) {
    var generado = "";
    var valorAnio = campoAnio.value;
    var valorIdTipoCiclo;
    if (campoTipoCiclo.options.length > 0) {
        valorIdTipoCiclo = campoTipoCiclo.options[campoTipoCiclo.selectedIndex].value;
    }
    var valorIdPeriodoInicio;
    if (campoPeriodoInicio.options.length > 0) {
        valorIdPeriodoInicio = campoPeriodoInicio.options[campoPeriodoInicio.selectedIndex].value;
    }
    var valorFechaInicio = campoFechaInicio.value;
    var valido = validar(campoAnio, valorAnio, campoTipoCiclo, valorIdTipoCiclo, campoPeriodoInicio, valorIdPeriodoInicio, campoFechaInicio, valorFechaInicio);

    var resp;
    if (valido == true) {
        $.ajax({
            type: "POST",
            contentType: "application/json; charset=utf-8",
            url: "../ServicioValidaciones.asmx/generarPeriodosPresupuesto",
            data: "{valorAnio:" + valorAnio + ", valorIdTipoCiclo:" + valorIdTipoCiclo + ", valorIdPeriodoInicio:" + valorIdPeriodoInicio + ", valorFechaInicio:'" + valorFechaInicio + "'}",
            dataType: "json",
            async: false,
            success: function (Result) {
                resp = JSON.parse(Result.d);
                var dataManagerDetalles = ej.DataManager(resp);
                $(gvsPeriodos).ejGrid("option", { dataSource: [] });
                $(gvsPeriodos).ejGrid({
                    dataSource: dataManagerDetalles,
                    allowPaging: true
                });
            },
            error: function (e) {
                generado = "No";
                alert(JSON.parse(e.responseText).Message);
                $(gvsPeriodos).ejGrid("option", { dataSource: [] });
            }
        });
    } else {
        generado = "No";
        alert("Error al validar en generarPeriodosPresupuesto()");
    }
    console.log(generado);
    return generado;
}

function GuardarGrupoPeriodos(campoAnio, campoTipoCiclo, campoPeriodoInicio, campoFechaInicio) {
    var valorAnio = campoAnio.value;
    var valorIdTipoCiclo;
    if (campoTipoCiclo.options.length > 0) {
        valorIdTipoCiclo = campoTipoCiclo.options[campoTipoCiclo.selectedIndex].value;
    }
    var valorIdPeriodoInicio;
    if (campoPeriodoInicio.options.length > 0) {
        valorIdPeriodoInicio = campoPeriodoInicio.options[campoPeriodoInicio.selectedIndex].value;
    }
    var valorFechaInicio = campoFechaInicio.value;

    var valido = validar(campoAnio, valorAnio, campoTipoCiclo, valorIdTipoCiclo, campoPeriodoInicio, valorIdPeriodoInicio, campoFechaInicio, valorFechaInicio);

    var resp;
    if (valido == true) {
        $.ajax({
            type: "POST",
            contentType: "application/json; charset=utf-8",
            url: "../ServicioValidaciones.asmx/GuardarGrupoPeriodos",
            data: "{valorAnio:" + valorAnio + ", valorIdTipoCiclo:" + valorIdTipoCiclo + ", valorIdPeriodoInicio:" + valorIdPeriodoInicio + ", valorFechaInicio:'" + valorFechaInicio + "'}",
            dataType: "json",
            async: false,
            success: function (Result) {
                resp = Result.d;
            },
            error: function (e) {
                alert(JSON.parse(e.responseText).Message + " método GuardarGrupoPeriodos()");
            }
        });

        if (resp == "") {
            mostrarMensaje("Periodos generados correctamente")
        }
    } else {
        alert("Error al validar en GuardarGrupoPeriodos()");
    }
}

function actualizarPeriodoAnio(campoPeriodoBase, campoPeriodo, campoAnio, campoFechaInicio, campoFechaFin, valorEstado, gvsPeriodosGeneradosAnio, campoBotonGuardar, campoBotonCancelar) {
    var valorIdPresupuestoPeriodo = campoPeriodo.value;
    var valorIdPresupuestoPeriodoBase = campoPeriodoBase.value;
    var valorAnio = campoAnio.value;
    var valorFechaInicio = campoFechaInicio.value;
    var valorFechaFin = campoFechaFin.value;
    var resp;
    $.ajax({
        type: "POST",
        contentType: "application/json; charset=utf-8",
        url: "../ServicioValidaciones.asmx/actualizarPeriodo",
        data: "{valorIdPresupuestoPeriodoBase:'" + valorIdPresupuestoPeriodoBase + "', valorIdPresupuestoPeriodo:'" + valorIdPresupuestoPeriodo + "', valorAnio:'" + valorAnio + "', valorFechaInicio:'" + valorFechaInicio + "', valorFechaFin:'" + valorFechaFin + "', valorEstado:'" + valorEstado + "'}",
        dataType: "json",
        async: false,
        success: function (Result) {
            resp = Result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message + " método actualizarPeriodoAnio()");
        }
    });

    if (resp == "") {
        mostrarMensaje("Periodo actualizado correctamente")
        mostrarPeriodosAnio(campoAnio, gvsPeriodosGeneradosAnio)
        campoBotonGuardar.style.display = 'none';
        campoBotonCancelar.style.display = 'none';
    }

}

function validar(campoAnio, valorAnio, campoTipoCiclo, valorIdTipoCiclo, campoPeriodoInicio, valorIdPeriodoInicio, campoFechaInicio, valorFechaInicio) {
    var valido = true;
    if (isNumeric(valorAnio) != true) {
        valido = false;
        alert("Ingrese un valor numérico");
        campoAnio.focus();
    }
    if (campoTipoCiclo.options.length <= 0) {
        valido = false;
        alert("Seleccione tipo de ciclo");
        campoTipoCiclo.focus();
    }
    if (campoPeriodoInicio.options.length <= 0) {
        valido = false;
        alert("Seleccione periodo de inicio");
        campoPeriodoInicio.focus();
    }
    if (valorFechaInicio == "__/__/____") {
        valido = false;
        alert("Ingrese fecha inicial");
        campoFechaInicio.focus();
    }
    return valido;
}

function mostrarPeriodosAnio(campoAnio, gvsPeriodosGeneradosAnio) {
    var valorAnio = campoAnio.value;
    $.ajax({
        type: "POST",
        contentType: "application/json; charset=utf-8",
        url: "../ServicioValidaciones.asmx/mostrarPeriodosAnio",
        data: "{valorAnio:'" + valorAnio + "'}",
        dataType: "json",
        async: false,
        success: function (Result) {
            resp = JSON.parse(Result.d);
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message + " método mostrarPeriodosAnio()");
        }
    });

    if (resp != "No implementado método mostrarPeriodosAnio()") {
        var dataManagerDetalles = ej.DataManager(resp);

        $(gvsPeriodosGeneradosAnio).ejGrid("option", { dataSource: [] });
        $(gvsPeriodosGeneradosAnio).ejGrid({
            dataSource: dataManagerDetalles,
            allowPaging: true
        });
    }
}