﻿function llamarWebService() {

    //Llamando el servicio
    $.ajax({
        url: "../ServicioValidaciones.asmx/HelloWorld",
        type: "POST",
        dataType: "json",
        data: "{}",
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            alert(result.d);
        },
        error: function (e) {
            var err = eval("(" + e.responseText + ")");

            // Display the error "growl", with a title of "Error",
            //  the error message as content, and a 20s display time.
            $.growlUI('Error', err.Message, 20000);
        }
    });
}

//dependiendo del tipo de recurso eleccionado buscapor el codigo y coloca la descripción en el campo descripción.
function obtenerRecursoPorTipo(idCampoTipo, idCampoCodigo, idCampoResponsable, idCampoDescripcion) {

    var campoTipo = document.getElementById(idCampoTipo);
    var campoRecurso = document.getElementById(idCampoCodigo);
    var campoResponsable = document.getElementById(idCampoResponsable);

    //Llamando el servicio
    $.ajax({
        url: "../ServicioValidaciones.asmx/ObtenerRecursoPorTipo",
        type: "POST",
        dataType: "text",
        data: "{tipoRecurso:'" + campoTipo.value + "', codigoRecurso:'" + campoRecurso.value + "', CodigoResponsable:'" + campoResponsable.value + "' }",
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            var campoDescripcion = document.getElementById(idCampoDescripcion);
            campoDescripcion.value = result;
        },
        error: function (e) {
            campoRecurso.focus();
            alert(JSON.parse(e.responseText).Message);
        }
    });
}

function obtenerListaRecursosPorTipo(campoTipo, campoResponsable) {
    //Llamando el servicio
    $.ajax({
        url: "../ServicioValidaciones.asmx/ObtenerListaRecursosPorTipo",
        type: "POST",
        dataType: "json",
        data: "{tipoRecurso:'" + campoTipo.value + "', CodigoResponsable:'" + campoResponsable.value + "' }",
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            listaRecurso = JSON.parse(result.d);
        },
        error: function (e) {
            CampoTipo.focus();
            alert(JSON.parse(e.responseText).Message);
        }
    });
}

function obtenerListaActividadesPorTipo(idTipoPlan) {
    //Llamando el servicio
    $.ajax({
        url: "../ServicioValidaciones.asmx/ObtenerListaActividadesPorTipo",
        type: "POST",
        dataType: "json",
        data: "{idTipoPlan:'" + idTipoPlan + "' }",
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            listaActividades = JSON.parse(result.d);
        },
        error: function (e) {
            CampoTipo.focus();
            alert(JSON.parse(e.responseText).Message);
        }
    });
}

function verificarLotePlanAnterior(idcampoLote, idCampoLinea, idCampoPalma, idCampoRevision, idCampoUma, idUnidad, idRendimiento) {
    var campoLote = document.getElementById(idcampoLote);
    var campoRevision = document.getElementById(idCampoRevision);
    var campoUma = document.getElementById(idCampoUma);
    var campoLinea = document.getElementById(idCampoLinea);
    var campoPalma = document.getElementById(idCampoPalma);
    var campoUnidad = document.getElementById(idUnidad);
    var campoRendimiento = document.getElementById(idRendimiento);

    //limpia campos dependientes
    if (campoUma != undefined) {
        campoUma.value = '';
    }
    campoLinea.value = '';
    campoPalma.value = '';
    campoUnidad.value = '';
    campoRendimiento.value = '';

    //verifica si se digitó el lote
    if (campoLote.value == '') {
        alert('Es necesario que especifique el Lote');
        campoLote.focus();
        return;
    }

    // valido que el lote digitado se valido
    //var existeLote = verificarExisteLote(campoLote.value);

    var existeLote = "False";

    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarExisteLote",
        type: "POST",
        dataType: "json",
        data: "{idLote:'" + campoLote.value + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            existeLote = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });
    console.log("Valor existelote " + existeLote);
    //busca el codigo de la actividad en la lsta
    if (existeLote == "True") {
        campoLote.value = campoLote.value.toUpperCase();
    } else {
        notificarFallaValidacion(campoLote, "El Lote: " + campoLote.value + " no se encuentra registrado en la base de datos o se encuentra inactivo", "");
        return false;
    }

    //En caso  que el campo revisión este oculto no lo evalua
    if (campoRevision == 'Undefined' || campoRevision == null) {
        return false
    }

    //en caso que se halla digitado la revisión vrifica si el lotes esta asociado a esa revisión
    if (campoRevision.value != "") {
        var valRev = "False";

        $.ajax({
            url: "../ServicioValidaciones.asmx/VerificarAsociacionLoteRevision",
            type: "POST",
            dataType: "json",
            data: "{idLote:'" + campoLote.value + "', idRevision:'" + campoRevision.value + "'}",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                valRev = result.d;
            },
            error: function (e) {
                alert(JSON.parse(e.responseText).Message);
                return false;
            }
        });

        if (valRev == "True") {
            if (campoUma != undefined) {//verificamos si el campo uma esta activo y visible
                if (campoUma.visibility == "visible") {//si el campo uma está visible entones le asigno el foco a ese campo
                    campoUma.focus();
                }
            }

        } else {
            notificarFallaValidacion(campoLote, "El Lote no se encuentra asociado a la revisión", "");
            return false;
        }

    }
}


function verificarLote(idcampoLote, idCampoLinea, idCampoPalma, idCampoRevision, idCampoUma, idUnidad, idRendimiento, lista) {
    var campoLote = document.getElementById(idcampoLote);
    var campoRevision = document.getElementById(idCampoRevision);
    var campoUma = document.getElementById(idCampoUma);
    var campoLinea = document.getElementById(idCampoLinea);
    var campoPalma = document.getElementById(idCampoPalma);
    var campoUnidad = document.getElementById(idUnidad);
    var campoRendimiento = document.getElementById(idRendimiento);

    //limpia campos dependientes
    if (campoUma != undefined) {
        campoUma.value = '';
    }
    campoLinea.value = '';
    campoPalma.value = '';
    campoUnidad.value = '';
    campoRendimiento.value = '';

    //verifica si se digitó el lote
    if (campoLote.value == '') {
        alert('Es necesario que especifique el Lote');
        campoLote.focus();
        return;
    }

    // valido que el lote digitado se valido
    //var existeLote = verificarExisteLote(campoLote.value);

    var existeLote = "False";
    var loteRelacionado = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarExisteLote",
        type: "POST",
        dataType: "json",
        data: "{idLote:'" + campoLote.value + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            existeLote = result.d;
        },
        error: function (e) {
            existeLote = "False";
            //alert(JSON.parse(e.responseText).Message);
            //return false;
        }
    });
    //como la lista aun no está cargada cuando se injecta el codigo javascript, se busca la lista en memoria por el nombre
    var myList = eval(lista);
    //busca el codigo de la actividad en la lsta
    for (i = 0; i < myList.length; i++) {
        if (myList[i].Codigo == campoLote.value.toUpperCase()) {
            if (existeLote == "True") {
                campoLote.value = myList[i].Codigo;
                campoUnidad.textContent = myList[i].Unidad;
                campoRendimiento.value = myList[i].Rendimiento.toString().replace('.', ',');
                loteRelacionado = "True";                
            }
            break;
        }
    }



    if (existeLote == "False") {
        notificarFallaValidacion(campoLote, "El Lote: " + campoLote.value + " no se encuentra registrado en la base de datos o se encuentra inactivo", "");        
        return false;
    } else if (existeLote == "True" && loteRelacionado == "False") {
        notificarFallaValidacion(campoLote, "El Lote: " + campoLote.value + " no se encuentra asociado a esta actividad o esta se encuentra inactiva en el lote!", "");
        return false;
    }


    //if (existeLote=="False") {
    //    notificarFallaValidacion(campoLote, "El Lote: " + campoLote.value + " no se encuentra asociado a esta actividad!","");
    //    return false;
    //}

    //En caso  que el campo revisión este oculto no lo evalua
    if (campoRevision == 'Undefined' || campoRevision == null) {
        return false
    }

    if (campoRevision == null) {
        return false;
    }

    //en caso que se halla digitado la revisión vrifica si el lotes esta asociado a esa revisión
    if (campoRevision.value != "") {
        var valRev = "False";

        $.ajax({
            url: "../ServicioValidaciones.asmx/VerificarAsociacionLoteRevision",
            type: "POST",
            dataType: "json",
            data: "{idLote:'" + campoLote.value + "', idRevision:'" + campoRevision.value + "'}",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                valRev = result.d;
            },
            error: function (e) {
                alert(JSON.parse(e.responseText).Message);
                return false;
            }
        });

        if (valRev == "True") {
            if (campoUma != undefined) {//verificamos si el campo uma esta activo y visible
                if (campoUma.visibility == "visible") {//si el campo uma está visible entones le asigno el foco a ese campo
                    campoUma.focus();
                }
            }

        } else {
            notificarFallaValidacion(campoLote, "El Lote no se encuentra asociado a la revisión", "");
            return false;
        }

    }
}

function verificarLinea(idCampoLinea, idcampoLote, idCampoPalma, idCampoRevision, tipoPlan, tipoSanidad) {
    var campoLote = document.getElementById(idcampoLote);
    var campoRevision = document.getElementById(idCampoRevision);
    var campoLinea = document.getElementById(idCampoLinea);
    var campoPalma = document.getElementById(idCampoPalma);

    //limpia los campos dependientes
    campoPalma.value = '';

    //verifica si se digitó el lote
    if (isNumeric(campoLinea.value) == false) {
        notificarFallaValidacion(campoLinea, 'Es campo línea debe ser un valor numérico', "");
        return;
    }

    // valido que el lote digitado se valido
    //var existeLote = verificarExisteLote(campoLote.value);

    var existeLinea = "False";

    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarExisteLinea",
        type: "POST",
        dataType: "json",
        data: "{idLote:'" + campoLote.value + "', idLinea:'" + campoLinea.value + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            existeLinea = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });


    if (existeLinea == "True") {
        campoLinea.value = campoLinea.value.toUpperCase();
    } else {
        notificarFallaValidacion(campoLinea, "La línea: " + campoLinea.value + " no existe para el Lote: " + campoLote.value + "!", "");
        return false;
    }

    //En caso  que el campo revisión este oculto no lo evalua
    if (campoRevision == 'Undefined' || campoRevision == null) {
        return false
    }

    if (campoRevision != null) {
        //en caso que se halla digitado la revisión vrifica si el lotes esta asociado a esa revisión y a la línea
        if ((campoRevision.value != "") && (tipoPlan == tipoSanidad)) {
            var valRev = "False";

            $.ajax({
                url: "../ServicioValidaciones.asmx/VerificarAsociacionLoteLineaRevision",
                type: "POST",
                dataType: "json",
                data: "{idLote:'" + campoLote.value + "', idRevision:'" + campoRevision.value + "', idLinea:'" + campoLinea.value + "'}",
                async: false,
                contentType: "application/json; charset=utf-8",
                success: function (result) {
                    valRev = result.d;
                },
                error: function (e) {
                    alert(JSON.parse(e.responseText).Message);
                    return false;
                }
            });

            if (valRev != "True") {//en caso que no encuentra la linea con la revision y el lote manda excepcion
                notificarFallaValidacion(campoLinea, "La línea no se encuentra asociada a la revisión", "");
                return false;
            }
        }
    }
}

function verificarPalma(idCampoPalma, idCampoLinea, idcampoLote, idCampoRevision, tipoPlan, tipoSanidad) {
    var campoLote = document.getElementById(idcampoLote);
    var campoRevision = document.getElementById(idCampoRevision);
    var campoLinea = document.getElementById(idCampoLinea);
    var campoPalma = document.getElementById(idCampoPalma);


    //verifica si se digitó el lote
    if (isNumeric(campoPalma.value) == false) {
        notificarFallaValidacion(campoPalma, 'Es campo Palma debe ser un valor numérico', "");
        return;
    }

    // valido que el lote digitado se valido
    //var existeLote = verificarExisteLote(campoLote.value);

    var existePalma = "False";

    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarExistePalma",
        type: "POST",
        dataType: "json",
        data: "{idLote:'" + campoLote.value + "', idLinea:'" + campoLinea.value + "', idPalma:'" + campoPalma.value + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            existePalma = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });


    if (existePalma == "True") {
        campoPalma.value = campoPalma.value.toUpperCase();
    } else {
        notificarFallaValidacion(campoPalma, "La Palma: " + campoPalma.value + " no existe para el Línea: " + campoLinea.value + "!", "");
        return false;
    }

    //En caso  que el campo revisión este oculto no lo evalua
    if (campoRevision == 'Undefined' || campoRevision == null) {
        return false
    }

    //en caso que se halla digitado la revisión vrifica si el lotes esta asociado a esa revisión y a la línea
    if ((campoRevision.value != "") && (tipoPlan == tipoSanidad)) {
        var valRev = "False";

        $.ajax({
            url: "../ServicioValidaciones.asmx/VerificarAsociacionLoteLineaPalmaRevision",
            type: "POST",
            dataType: "json",
            data: "{idLote:'" + campoLote.value + "', idRevision:'" + campoRevision.value + "', idLinea:'" + campoLinea.value + "', idPalma:'" + campoPalma.value + "'}",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                valRev = result.d;
            },
            error: function (e) {
                alert(JSON.parse(e.responseText).Message);
                return false;
            }
        });

        if (valRev != "True") {//en caso que no encuentra la linea con la revision y el lote manda excepcion
            notificarFallaValidacion(campoPalma, "La palma no se encuentra asociada a la revisión", "");
            return false;
        }
    }
}

function obtenerListaActividadesPorLote(idLote, idTipoPlan) {
    var campoLote = document.getElementById(idLote);

    //limpia la lista
    listaActividades = '';

    //Llamando el servicio
    $.ajax({
        url: "../ServicioValidaciones.asmx/ObtenerListActividades",
        type: "POST",
        dataType: "json",
        data: "{idLote:'" + campoLote.value + "', idTipoPlan:'" + idTipoPlan + "' }",
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            listaActividades = JSON.parse(result.d);
        },
        error: function (e) {
            campoLote.focus();
            alert(JSON.parse(e.responseText).Message);
        }
    });
}

function obtenerListaUmasPorLote(idLote, idCampoUma) {
    var campoLote = document.getElementById(idLote);
    var campoUma = document.getElementById(idCampoUma);


    //limpia la lista
    listaUmas = '';

    if (campoUma != undefined) {//verificamos si el campo uma esta activo y visible
        if (campoUma.visibility = "visible") {//si el campo uma está visible entones le asigno el foco a ese campo
            //Llamando el servicio
            $.ajax({
                url: "../ServicioValidaciones.asmx/ObtenerListUmaPorLote",
                type: "POST",
                dataType: "json",
                data: "{idLote:'" + campoLote.value + "' }",
                contentType: "application/json; charset=utf-8",
                success: function (result) {
                    listaUmas = JSON.parse(result.d);
                },
                error: function (e) {
                    campoLote.focus();
                    alert(JSON.parse(e.responseText).Message);
                }
            });
        }
    }
}

function verificarRevision(idRevision, idPalma, idLinea, idLote, tipoPlan, tipoSanidad) {
    var campoLote = document.getElementById(idLote);
    var campoRevision = document.getElementById(idRevision);
    var campoLinea = document.getElementById(idLinea);
    var campoPalma = document.getElementById(idPalma);


    //en caso que se halla digitado la revisión vrifica si el lotes esta asociado a esa revisión y a la línea
    if ((campoRevision.value != "") && (tipoPlan == tipoSanidad)) {
        var valRev = "False";

        $.ajax({
            url: "../ServicioValidaciones.asmx/VerificarAsociacionLoteLineaPalmaRevision",
            type: "POST",
            dataType: "json",
            data: "{idLote:'" + campoLote.value + "', idRevision:'" + campoRevision.value + "', idLinea:'" + campoLinea.value + "', idPalma:'" + campoPalma.value + "'}",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                valRev = result.d;
            },
            error: function (e) {
                alert(JSON.parse(e.responseText).Message);
                return false;
            }
        });

        if (valRev != "True") {//en caso que no encuentra la linea con la revision y el lote manda excepcion
            notificarFallaValidacion(campoRevision, "Este Lote Linea palma no se encuentra asociada a la revisión", "");
            return false;
        }
    }
}

function obtenerListaLotesPorActividad(idActividad, idTipoPlan) {
    var campoActividad = document.getElementById(idActividad);

    //limpia la lista
    listaLotes = '';

    //Llamando el servicio
    $.ajax({
        url: "../ServicioValidaciones.asmx/ObtenerListaLotesPorActividad",
        type: "POST",
        dataType: "json",
        data: "{idActividad:'" + campoActividad.value + "', idTipoPlan:'" + idTipoPlan + "' }",
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            listaLotes = JSON.parse(result.d);
        },
        error: function (e) {
            campoActividad.focus();
            alert(JSON.parse(e.responseText).Message);
        }
    });
}

function verificarExisteLote(idLote) {
    //Llamando el servicio
    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarExisteLote",
        type: "POST",
        dataType: "text",
        data: "{idLote:'" + idLote + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            var resultado = result
            return result;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });
}

function verificarAsociacionRevisionLote(idLote, idRevision) {
    //Llamando el servicio
    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarAsociacionLoteRevision",
        type: "POST",
        dataType: "json",
        data: "{idLote:'" + idLote + "', idRevision:'" + idRevision + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            return result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });
}

function ActualizarRecursoPlanAccion(idPlan, idDetalle, jsonEnviar) {
    var valRev = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/ActualizarRecurso",
        type: "POST",
        dataType: "json",
        data: "{idPlanAccion:'" + idPlan + "', idDetallePlanAccion:'" + idDetalle + "', JsonListaRecursoEditar:'" + jsonEnviar + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            valRev = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });

    if (valRev != "True") {//en caso que no encuentra la linea con la revision y el lote manda excepcion
        return false;
    } else {
        return true
    }
}

function EliminarDetallePlan(idPlan, jsonEnviar) {
    var valRev = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/EliminarDetallePlanAccion",
        type: "POST",
        dataType: "json",
        data: "{idPlanAccion:'" + idPlan + "', JsonListaDetalleEliminar:'" + jsonEnviar + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            valRev = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });

    if (valRev != "True") {//en caso que no encuentra la linea con la revision y el lote manda excepcion
        return false;
    } else {
        return true
    }
}

function verificarExisteRevision(idCampoRevision, idcampoLote, idCampoLinea, idCampoPalma, idCampoUma, idUnidad, idRendimiento) {
    var campoLote = document.getElementById(idcampoLote);
    var campoRevision = document.getElementById(idCampoRevision);
    var campoUma = document.getElementById(idCampoUma);
    var campoLinea = document.getElementById(idCampoLinea);
    var campoPalma = document.getElementById(idCampoPalma);
    var campoUnidad = document.getElementById(idUnidad);
    var campoRendimiento = document.getElementById(idRendimiento);

    //limpia campos dependientes
    if (campoUma != undefined) {
        campoUma.value = '';
    }
    campoLinea.value = '';
    campoPalma.value = '';
    campoUnidad.value = '';
    campoRendimiento.value = '';
    campoLote.value = '';

    //verifica si se digitó el lote
    if (campoRevision.value == '') {
        alert('Es necesario que especifique elnúmero de la revisión');
        campoRevision.focus();
        return;
    }

    // valido que la revisión exista
    var existeRevision = "False";

    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarExisteRevision",
        type: "POST",
        dataType: "json",
        data: "{idRevision:'" + campoRevision.value + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            existeRevision = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });


    if (existeRevision == "False") {
        notificarFallaValidacion(campoRevision, "La revisión No.: " + campoRevision.value + " no se encuentra dentro del listado de revisiones!", "");
        return false;
    }
}



function obtenerListaDetallesPorPlanAccion(idPlanAccion, idControl) {
    var campoPlanAccion = document.getElementById(idPlanAccion);
    var campoControlLabores = document.getElementById(idControl);

    //limpia la lista
    listaDetalles = '';

    //Llamando el servicio
    $.ajax({
        url: "../ServicioValidaciones.asmx/obtenerListaDetallesPorPlanAccion",
        type: "POST",
        dataType: "json",
        data: "{numeroPlanAccion:'" + campoPlanAccion.value + "', numeroControl:'" + campoControlLabores.value + "' }",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            listaDetalles = JSON.parse(result.d);
        },
        error: function (e) {
            campoPlanAccion.focus();
            alert(JSON.parse(e.responseText).Message);
        }
    });
}

function validarActividadCumplida(idPlanAccion, idDetallePlanAccion, idRendimientoActividad, idEstadoActividad, idTipoPago) {
    var campoPlanAccion = document.getElementById(idPlanAccion);
    var campoDetallePlanAccion = document.getElementById(idDetallePlanAccion);
    var campoRendimientoActividad = document.getElementById(idRendimientoActividad);
    var campoTipoPago = document.getElementById(idTipoPago);

    var rendimientoActividad = campoRendimientoActividad.value;
    var rendimiento = 0;


    //verificamos que no este vacío el rendimiento
    if (rendimientoActividad == "") {
        alert(" Es necesario que se especifíque el Rendimiento");
        campoRendimientoActividad.focus();
        return false;
    } else {
        var validoComa = /^([0-9])*[,]?[0-9]*$/.test(rendimiento)
        var validoPunto = /^([0-9])*[.]?[0-9]*$/.test(rendimiento)
        if (validoComa == true || validoPunto == true) {
            //Llamando el servicio
            $.ajax({
                url: "../ServicioValidaciones.asmx/obtenerRendimientoEstandar",
                type: "POST",
                dataType: "json",
                data: "{numeroPlanAccion:'" + campoPlanAccion.value + "', numeroDetallePlanAccion:'" + campoDetallePlanAccion.value + "' }",
                async: false,
                contentType: "application/json; charset=utf-8",
                success: function (result) {
                    rendimiento = result.d;
                },
                error: function (e) {
                    campoRendimientoActividad.value = '';
                    campoRendimientoActividad.focus();
                    alert(JSON.parse(e.responseText).Message);
                }
            });

            var campoEstadoActividad = document.getElementById(idEstadoActividad);

            var rendimientoComparar = rendimientoActividad.replace(',', '.');
            if (rendimientoComparar >= rendimiento) {
                campoEstadoActividad.value = 'C';
                campoTipoPago.focus();
            } else {
                campoEstadoActividad.value = 'N';
                campoTipoPago.focus();
            }
        } else {
            alert(" El rendimiento debe ser un valor Númerico");
            campoRendimientoActividad.focus();
            return false;
        }
    }
}

function ActualizarDetallesControl(numeroControlLabores, jsonEnviar) {
    var valRev = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/ActualizarDetallesControl",
        type: "POST",
        dataType: "json",
        data: "{numeroControlLabores:'" + numeroControlLabores + "', JsonListaDetalles:'" + jsonEnviar + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            valRev = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });

    if (valRev != "True") {//en caso que no encuentra la linea con la revision y el lote manda excepcion
        return false;
    } else {
        return true
    }
}

function ActualizarRecursoDetalleControl(idControl, idPlanAccion, idDetallePlanAccion, jsonEnviar) {
    var valRev = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/ActualizarRecursoDetalleControl",
        type: "POST",
        dataType: "json",
        data: "{idControl:'" + idControl + "', idPlanAccion:'" + idPlanAccion + "', idDetallePlanAccion:'" + idDetallePlanAccion + "', JsonListaRecursoEditar:'" + jsonEnviar + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            valRev = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });

    if (valRev != "True") {//en caso que no encuentra la linea con la revision y el lote manda excepcion
        return false;
    } else {
        return true
    }
}

function ActualizarDetalleRemision(numeroRemision, numeroPagina, numeroDetalle, jsonEnviar) {
    var valRev = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/ActualizarDetalleRemision",
        type: "POST",
        dataType: "json",
        data: "{numeroRemision:'" + numeroRemision + "', numeroPagina:'" + numeroPagina + "', numeroDetalle:'" + numeroDetalle + "', JsonListaRecursoEditar:'" + jsonEnviar + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            valRev = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });

    if (valRev != "True") {
        return false;
    } else {
        return true
    }
}

function ActualizarCuadrillaDetalleRemision(numeroRemision, numeroPagina, numeroDetalle, jsonEnviar) {
    var valRev = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/ActualizarCuadrillaDetalleRemision",
        type: "POST",
        dataType: "json",
        data: "{numeroRemision:'" + numeroRemision + "', numeroPagina:'" + numeroPagina + "', numeroDetalle:'" + numeroDetalle + "', JsonListaRecursoEditar:'" + jsonEnviar + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            valRev = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });

    if (valRev != "True") {
        return false;
    } else {
        return true
    }
}

function ActualizarCargadoresRemision(numeroRemision, numeroPagina, jsonEnviar) {
    var valRev = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/ActualizarCargadoresRemision",
        type: "POST",
        dataType: "json",
        data: "{numeroRemision:'" + numeroRemision + "', numeroPagina:'" + numeroPagina + "', JsonListaRecursoEditar:'" + jsonEnviar + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            valRev = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
        }
    });

    if (valRev != "True") {//en caso que no encuentra la linea con la revision y el lote manda excepcion
        return false;
    } else {
        return true
    }
}


//---------------------------------------------------------------------------------------------------------------------

function verificarExisteBloque(idcampoActual, idCampoSiguiente) {
    var campoActual = document.getElementById(idcampoActual);
    var campoSiguiente = document.getElementById(idCampoSiguiente);
    //verifica si se digitó el bloque
    if (campoActual.value == '') {
        alert('Es necesario que especifique el Bloque');
        campoActual.focus();
        return;
    }

    var existeBloque = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarExisteBloque",
        type: "POST",
        dataType: "json",
        data: "{bloque:'" + campoActual.value + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            existeBloque = result.d;
        },
        error: function (e) {
            existeBloque = "False";
        }
    });

    if (existeBloque == "False") {
        notificarFallaValidacion(campoActual, "El Bloque: " + campoActual.value + " no se encuentra registrado en la base de datos", "");
        return false;
    } else {
        campoActual.value = campoActual.value.toUpperCase();
    }
}

function verificarExisteLote(idcampoLote, idCampoLinea) {
    var campoLote = document.getElementById(idcampoLote);
    var campoLinea = document.getElementById(idCampoLinea);

    //verifica si se digitó el lote
    if (campoLote.value == '') {
        alert('Es necesario que especifique el Lote');
        campoLote.focus();
        return false;
    }

    var existeLote = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarExisteLote",
        type: "POST",
        dataType: "json",
        data: "{idLote:'" + campoLote.value + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            existeLote = result.d;
        },
        error: function (e) {
            existeLote = "False";
        }
    });

    if (existeLote == "False") {
        notificarFallaValidacion(campoLote, "El Lote: " + campoLote.value + " no se encuentra registrado en la base de datos", "");
        return false;
    } else {
        campoLote.value = campoLote.value.toUpperCase();
    }
    return existeLote;
}

function verificarExisteLineaEnLote(idCampoLinea, idCampoLote) {
    var campoLote = document.getElementById(idCampoLote);
    var campoLinea = document.getElementById(idCampoLinea);

    //verifica si se digitó el lote
    if (isNumeric(campoLinea.value) == false) {
        notificarFallaValidacion(campoLinea, 'Es campo línea debe ser un valor numérico', "");
        return;
    }
    var existeLinea = "false";
    $.ajax({
        url: "../ServicioValidaciones.asmx/VerificarExisteLinea",
        type: "POST",
        dataType: "json",
        data: "{idLote:'" + campoLote.value + "', idLinea:'" + campoLinea.value + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            existeLinea = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return existeLinea;
        }
    });

    if (existeLinea == "True") {
        campoLinea.value = campoLinea.value.toUpperCase();
    } else {
        notificarFallaValidacion(campoLinea, "La línea: " + campoLinea.value + " no existe para el Lote: " + campoLote.value + "!", "");
        return existeLinea;
    }
    return existeLinea;
}

function validarPalmaPerteneceLinea(idCampoPalma, idCampoLinea, idCampoLote) {
    var campoLote = document.getElementById(idCampoLote);
    var campoLinea = document.getElementById(idCampoLinea);
    var campoPalma = document.getElementById(idCampoPalma);

    //verifica si se digitó el lote
    if (isNumeric(campoPalma.value) == false) {
        notificarFallaValidacion(campoPalma, 'La línea debe ser un valor numérico', "");
        return;
    }
    var existePalma = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/verificarLineaPalma",
        type: "POST",
        dataType: "json",
        data: "{Lote:'" + campoLote.value + "', Linea:'" + campoLinea.value + "', Palma:'" + campoPalma.value + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            existePalma = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });

    if (existePalma == "True") {
        campoPalma.value = campoPalma.value.toUpperCase();
    } else {
        notificarFallaValidacion(campoPalma, "La palma: " + campoPalma.value + " no se encuentra en la linea: " + campoLinea.value + " o esta se encuentra erradicada!", "");
        return false;
    }
}


function validarRequiereUmaActividad(idCampoActividad, idCampoUma) {
    var campoActividad = document.getElementById(idCampoActividad);
    var campoUma = document.getElementById(idCampoUma);

    if (campoUma != undefined) {//verificamos si el campo uma esta activo y visible
        if (campoUma.visibility = "visible") {//si el campo uma está visible entones le asigno el foco a ese campo
            var requiereUma = "False";
            $.ajax({
                url: "../ServicioValidaciones.asmx/validarRequiereUmaActividad",
                type: "POST",
                dataType: "json",
                data: "{actividad:'" + campoActividad.value + "'}",
                async: false,
                contentType: "application/json; charset=utf-8",
                success: function (result) {
                    requiereUma = result.d;
                },
                error: function (e) {
                    alert(JSON.parse(e.responseText).Message);
                    return false;
                }
            });

            if (requiereUma == "True" && campoUma != "") {
                campoUma.value = campoUma.value.toUpperCase();
            } else {
                notificarFallaValidacion(campoUma, "La actividad: " + campoActividad.value + " requiere de una uma para poder ser planeada", "");
                return false;
            }
        }
    }
}



function verificarPalmaLineaLote(idCampoPalma, idCampoLote, idCampoLinea, idCampoPalmaInicial, idCampoUma) {
    var campoLote = document.getElementById(idCampoLote);
    var campoLinea = document.getElementById(idCampoLinea);
    var campoPalma = document.getElementById(idCampoPalma);
    var campoPalmaInicial = document.getElementById(idCampoPalmaInicial);
    var campoUma = document.getElementById(idCampoUma);

    if ((/^\s*$/).test(campoPalma.value) == false) {
        if (isNumeric(campoPalma.value)) {
            if (parseInt(campoPalma.value) >= parseInt(campoPalmaInicial.value)) {
                var palmaLineaLote = "false";
                $.ajax({
                    url: "../ServicioValidaciones.asmx/verificarPalmaLineaLote",
                    type: "POST",
                    dataType: "json",
                    data: "{lote:'" + campoLote.value + "', linea:'" + campoLinea.value + "', palma:'" + campoPalma.value + "'}",
                    async: false,
                    contentType: "application/json; charset=utf-8",
                    success: function (result) {
                        palmaLineaLote = result.d;
                    },
                    error: function (e) {
                        alert(JSON.parse(e.responseText).Message);
                        return false;
                    }
                });
                if (palmaLineaLote.toString() == "false") {
                    campoUma.focus();
                } else {
                    notificarFallaValidacion(campoPalma, "El valor para la palma: " + campoPalma.value + " ya se encuentra asociado a la línea del lote", "");
                    return false;
                }
            } else {
                notificarFallaValidacion(campoPalma, "El valor para la palma: " + campoPalma.value + " debe ser mayor o igual a la palma inicial", "");
                return false;
            }
        } else {
            notificarFallaValidacion(campoPalma, "El valor para la palma: " + campoPalma.value + " debe ser numérico", "");
            return false;
        }
    } else {
        notificarFallaValidacion(campoPalma, "Ingrese un valor para la palma", "");
        return false;
    }
}

function validarIdPlantilla(idCampoPlantilla, idNombrePlantilla) {
    var campoPlantilla = document.getElementById(idCampoPlantilla);
    var campoNombrePlantilla = document.getElementById(idNombrePlantilla);

    //verifica si se digitó el lote
    if (isNumeric(campoPlantilla.value) == false) {
        notificarFallaValidacion(campoPlantilla, 'El código de la plantilla debe ser un valor numérico', "");
        return;
    }
    var nombrePlantilla = "";
    $.ajax({
        url: "../ServicioValidaciones.asmx/obtenerNombreIdPlantilla",
        type: "POST",
        dataType: "json",
        data: "{idPlantilla:'" + campoPlantilla.value + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            nombrePlantilla = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });

    if (nombrePlantilla != "") {
        campoNombrePlantilla.value = nombrePlantilla;
    } else {
        notificarFallaValidacion(campoPlantilla, "El código de plantilla: " + campoPlantilla.value + " no se encuentra registrado o está inactivo", "");
        campoNombrePlantilla.value = "";
        return false;
    }
}

function ActualizarInformacionMetereologica(JsonInformacionEditar) {
    var valRev = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/ActualizarInformacionMetereologica",
        type: "POST",
        dataType: "json",
        data: "{JsonInformacionEditar:'" + JsonInformacionEditar + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            valRev = result.d;
        },
        error: function (e) {
            mostrarMensaje(JSON.parse(e.responseText).Message);
        }
    });

    if (valRev != "True") {
        return false;
    } else {
        return true
    }
}

function actualizarInformacionEvapotranspiracion(JsonInformacionEditar) {
    var valRev = "False";
    $.ajax({
        url: "../ServicioValidaciones.asmx/actualizarInformacionEvapotranspiracion",
        type: "POST",
        dataType: "json",
        data: "{JsonInformacionEditar:'" + JsonInformacionEditar + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            valRev = result.d;
        },
        error: function (e) {
            mostrarMensaje(JSON.parse(e.responseText).Message);
        }
    });

    if (valRev != "True") {
        return false;
    } else {
        return true
    }
}

//Region erradicación de palmas por renovación
function validacionGeneralMostrarPalmas(idCampoLote, idCampoControlLabor, idCampoLineaInicial, idCampoLineaFinal, idCampoPalmaInicial, idCampoPalmaFinal) {
    var valido = "false";
    //Campos
    var campoLote = document.getElementById(idCampoLote); var campoControlLabor = document.getElementById(idCampoControlLabor);
    var campoLineaInicial = document.getElementById(idCampoLineaInicial); var campoLineaFinal = document.getElementById(idCampoLineaFinal);
    var campoPalmaInicial = document.getElementById(idCampoPalmaInicial); var campoPalmaFinal = document.getElementById(idCampoPalmaFinal);
    
    //Valores de los campos
    //var lote = campoLote.value; var controlLabor = campoControlLabor.value;
    //var lineaInicial = campoLineaInicial.value; var lineaFinal = campoLineaFinal.value;
    //var palmaInicial = campoPalmaInicial.value; var palmaFinal = campoPalmaFinal.value;

    var loteValido = verificarExisteLote(idCampoLote, idCampoLineaInicial);
    console.log("Validacion lote " + loteValido);
    if (loteValido.toString().toUpperCase() == "TRUE") {
        var controlRenovacionValido = verificarActividadRenovacionLoteLinea(idCampoControlLabor, idCampoLote);
        //console.log("Validacion control " + controlRenovacionValido);
        if (controlRenovacionValido.toString().toUpperCase() == "TRUE") {
            var lineaInicialValida = verificarExisteLineaEnLote(idCampoLineaInicial, idCampoLote);
            //console.log("Validacion linea inicial " + lineaInicialValida);
            if (lineaInicialValida.toString().toUpperCase() == "TRUE") {
                var palmaInicialValida = verificarPalmaValidaLineaLote(idCampoPalmaInicial, idCampoLineaInicial, idCampoLote);
                //console.log("Validacion palma inicial " + palmaInicialValida);
                if (palmaInicialValida.toString().toUpperCase() == "TRUE") {
                    var lineaFinalValida = verificarLineaFinalMayorInicial(idCampoLineaFinal, idCampoLineaInicial, idCampoLote)
                    //console.log("Validacion linea final " + lineaFinalValida);
                    if (lineaFinalValida.toString().toUpperCase() == "TRUE") {
                        var palmaFinalValida = verificarPalmaMayorEntreLineas(idCampoPalmaFinal, idCampoLineaFinal, idCampoPalmaInicial, idCampoLineaInicial, idCampoLote);
                        //console.log("Validacion palma final " + palmaFinalValida);
                        if (palmaFinalValida.toString().toUpperCase() == "TRUE") {
                            valido = "True";
                        }
                    }
                }
            }
        }
    }
    return valido;
}


function verificarLineaFinalMayorInicial(idCampoLineaFinal, idCampoLineaInicial, idCampoLote) {
    var campoLote = document.getElementById(idCampoLote);
    var campoLineaFinal = document.getElementById(idCampoLineaFinal);
    var campoLineaInicial = document.getElementById(idCampoLineaInicial);
    var lineaFinal = campoLineaFinal.value;
    var lineaInicial = campoLineaInicial.value;

    var validacion = "false";
    //Validar linea final numérica
    if (isNumeric(lineaFinal) == false) {
        notificarFallaValidacion(campoLineaFinal, 'La linea final debe ser un valor numérico', "");
        return validacion;
    }

    //Validar linea inicial numérica
    if (isNumeric(lineaInicial) == false) {
        notificarFallaValidacion(campoLineaInicial, 'La linea inicial debe ser un valor numérico', "");
        return validacion;
    }
    console.log(lineaInicial)
    console.log(lineaFinal)

    if (parseInt(lineaFinal) >= parseInt(lineaInicial)) {
        validacion = verificarExisteLineaEnLote(idCampoLineaFinal, idCampoLote);
    } else {
        notificarFallaValidacion(campoLineaFinal, 'La linea final debe ser mayor o igual a la linea inicial', "");
        return validacion;
    }
    return validacion;
}

function verificarPalmaMayorEntreLineas(idCampoPalmaFinal, idCampoLineaFinal, idCampoPalmaInicial, idCampoLineaInicial, idCampoLote) {
    var campoLote = document.getElementById(idCampoLote);
    var campoLineaFinal = document.getElementById(idCampoLineaFinal); var campoPalmaFinal = document.getElementById(idCampoPalmaFinal);
    var campoLineaInicial = document.getElementById(idCampoLineaInicial); var campoPalmaInicial = document.getElementById(idCampoPalmaInicial);

    var validacion = "false";
    //Si tanto linea inicial como final son la misma se valida que la palma final sea mayor o igual a la inicial
    if (campoLineaInicial.value == campoLineaFinal.value) {
        if (campoPalmaFinal.value >= campoPalmaInicial.value) {
            validacion = verificarPalmaValidaLineaLote(idCampoPalmaFinal, idCampoLineaFinal, idCampoLote);
        } else {
            notificarFallaValidacion(campoPalmaFinal, 'La palma ' + campoPalmaFinal.value + " debe ser mayor o igual a la palma inicial " + campoPalmaInicial.value + " ya que se encuentran en la misma linea", "");
            validacion = "false";
            return validacion;
        }
        //Sino se valida si la relación lote linea palma exista
    } else {
        validacion =  verificarPalmaValidaLineaLote(idCampoPalmaFinal, idCampoLineaFinal, idCampoLote);
    }
    return validacion;
}

function verificarPalmaValidaLineaLote(idCampoPalma, idCampoLinea, idCampoLote) {
    var campoLote = document.getElementById(idCampoLote); var campoLinea = document.getElementById(idCampoLinea); var campoPalma = document.getElementById(idCampoPalma);
    var lote = campoLote.value; var linea = campoLinea.value; var palma = campoPalma.value; var relacionValida;
    $.ajax({
        url: "../ServicioValidaciones.asmx/validarRelacionLoteLineaPalma",
        type: "POST",
        dataType: "json",
        data: "{lote:'" + lote + "', linea:'" + linea + "', palma:'" + palma + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            relacionValida = result.d;
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            relacionValida = "false";
            return relacionValida;
        }
    });

    if (relacionValida.toString().toUpperCase() == "FALSE") {
        notificarFallaValidacion(campoPalma, 'La palma ' + palma + " no pertenece al lote " + lote + ", linea " + linea + " o esta se encuentra erradicada", "");
        relacionValida = "false";
        return relacionValida;
    } else {
        relacionValida = "True";        
    }
    return relacionValida;
}

function verificarActividadRenovacionLoteLinea(idCampoControlLabor, idCampoLote) {
    var campoLote = document.getElementById(idCampoLote);
    var campoControlLabor = document.getElementById(idCampoControlLabor);
    var registroActividad = "false";
    if (isNumeric(campoControlLabor.value)) {
        //Validar que el control labor este registrado y procesado
        var controlValido = "false";
        $.ajax({
            url: "../ServicioValidaciones.asmx/validarControlLaborProcesado",
            type: "POST",
            dataType: "json",
            data: "{numeroControlLabor:'" + campoControlLabor.value + "'}",
            async: false,
            contentType: "application/json; charset=utf-8",
            success: function (result) {
                controlValido = result.d;
            },
            error: function (e) {
                alert(JSON.parse(e.responseText).Message);
                registroActividad = "false";
                return registroActividad;
            }
        });

        //Si se encuentra que el control es válido se procede a verificar que se tenga el lote y la actividad de renovación
        //en el control labor
        if (controlValido.toString().toUpperCase() == "TRUE") {            
            $.ajax({
                url: "../ServicioValidaciones.asmx/validarActividadRenovacionEnDetallesControl",
                type: "POST",
                dataType: "json",
                data: "{numeroControlLabor:'" + campoControlLabor.value + "', codigoLote:'" + campoLote.value + "'}",
                async: false,
                contentType: "application/json; charset=utf-8",
                success: function (result) {
                    registroActividad = result.d;
                },
                error: function (e) {
                    alert(JSON.parse(e.responseText).Message);
                    registroActividad = "false";
                    return registroActividad;
                }
            });

            if (registroActividad.toString().toUpperCase() == "FALSE") {
                notificarFallaValidacion(campoControlLabor, "No se encuentra actividades de renovación de palmas para el lote " + campoLote.value + " en el control labor " + campoControlLabor.value, "");
                registroActividad = "false";
                return registroActividad;
            }
        } else {
            notificarFallaValidacion(campoControlLabor, "El control labor no existe o no se encuentra procesado", "");
            registroActividad = "false";
            return registroActividad;
        }
    } else {
        notificarFallaValidacion(campoControlLabor, "Ingrese un valor válido para el control labor", "");
        registroActividad = "false";
        return registroActividad;
    }
    return registroActividad;
}