﻿//Sección detalles
function validarPlanAccionProcesado(idCodigoPlan, idCodigoDetalle, lista) {
    var campo1 = document.getElementById(idCodigoPlan)
    var campo2 = document.getElementById(idCodigoDetalle)

    for (var i = 0; i < lista.length; i++) {
        console.log(lista[0].CODIGO);
        if (campo1.value == lista[i].CODIGO) {

            campo2.focus();
            return;
        }
    }
    notificarFallaValidacion(campo1, 'El código del plan de acción no existe', '');
    return false;
}

function validarDetallePlanAccion(idCampoDetalle, idCampoLote, idCampoUma, idCampoLinea, idCampoPalma, idCampoCodigoActividad,
    idCampoNombreActividad, idCampoRendimiento, idCampoUnidad, idCampoPago, lista) {

    console.log(lista);

    console.log(idCampoRendimiento)

    var campoDetalle = document.getElementById(idCampoDetalle);
    var campoLote = document.getElementById(idCampoLote);
    var campoUma = document.getElementById(idCampoUma);
    var campoLinea = document.getElementById(idCampoLinea);
    var campoPalma = document.getElementById(idCampoPalma);
    var campoCodigoActividad = document.getElementById(idCampoCodigoActividad);
    var campoNombreActividad = document.getElementById(idCampoNombreActividad);
    var campoRendimiento = document.getElementById(idCampoRendimiento);
    var campoUnidad = document.getElementById(idCampoUnidad);
    var campoPago = document.getElementById(idCampoPago);

    campoLote.value = '';
    campoUma.value = '';
    campoLinea.value = '';
    campoPalma.value = '';
    campoCodigoActividad.value = '';
    campoNombreActividad.value = '';
    campoRendimiento.value = '';
    campoUnidad.textContent = '';
    campoPago.value = '';

    //verifica si se digitó el detalle del plan de acción
    if (campoDetalle.value == '') {
        alert('Es necesario que especifique un detalle del plan de acción');
        campoDetalle.focus();
        return;
    }

    var myList = eval(lista);

    //como la lista aun no está cargada cuando se injecta el codigo javascript, se busca la lista en memoria por el nombre
    var myList = eval(lista);
    var programada = true;

    //busca el codigo de la actividad en la lista
    for (i = 0; i < myList.length; i++) {
        if (myList[i].DETALLE == campoDetalle.value) {
            campoLote.value = myList[i].LOTE;
            campoUma.value = myList[i].UMA;
            campoLinea.value = myList[i].LINEA;
            campoPalma.value = myList[i].PALMA;
            campoCodigoActividad.value = myList[i].LABOR;
            campoNombreActividad.value = myList[i].ACTIVIDAD;
            campoUnidad.textContent = myList[i].UNIDAD;
            campoPago.value = myList[i].TIPOPAGO;
            programada = false;
            campoRendimiento.focus();
            break;
        }
    }

    if (programada == true) {
        alert('La actividad no existe o ya se encuentra programada');
        campoDetalle.value = '';
        campoDetalle.focus();
    }
}

//Sección recursos

function obtenerNombrePorCodigo(idOrigen, idDestino, lista) {
    var campo1 = document.getElementById(idOrigen)
    var campo2 = document.getElementById(idDestino)

    for (var i = 0; i < lista.length; i++) {
        if (campo1.value == lista[i].Codigo) {
            campo2.value = lista[i].Descripcion;
            return;
        }
    }
    notificarFallaValidacion(campo1, 'Código no encontrado', '');
    campo1.value = '';
    campo2.value = '';
    return false;
}

function cambiarEstadoDetalleControl(estado, numeroControl, numeroPlan, numeroDetallePlan) {
    var valor = 0;
    $.ajax({
        url: "../ServicioValidaciones.asmx/cambiarEstadoDetalleControl",
        type: "POST",
        dataType: "json",
        data: "{estado:'" + estado + "', numeroControl:'" + numeroControl + "', numeroPlan: '" + numeroPlan + "', numeroDetallePlan: '" + numeroDetallePlan + "'}",
        async: false,
        contentType: "application/json; charset=utf-8",
        success: function (result) {
            valor = result.d;
            console.log("valor en success " + valor);            
        },
        error: function (e) {
            alert(JSON.parse(e.responseText).Message);
            return false;
        }
    });
    return valor;
}