﻿<%@ Page Title="" Language="VB" MasterPageFile="~/MasterPage.master" AutoEventWireup="false" CodeFile="Grafico.aspx.vb" Inherits="Grafico" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <div class="container">
        <div class="row">
            <div class="col-xs-12 col-md-8 col-lg-8 bordeGrafico text-center">
                <div id="mensajeGraficoFlujoCajaMensual" class="alert fade in alert-danger" runat="server">
                    <i class="icon-remove-circle"></i>
                    <asp:Label ID="mensaje1" runat="server" Text="sinInformacion"></asp:Label>
                </div>
                <ej:Chart ID="chFlujoCajaMensual" runat="server" CanResize="true" Theme="Azure" ClientIDMode="Static">
                    <Title Text="flujoCajaMensual" TextAlignment="Center">
                        <Font Color="#000" FontStyle="Bold" FontSize="20px" FontFamily="Segoe UI"></Font>
                        <SubTitle TextAlignment="Center"></SubTitle>
                    </Title>
                    <PrimaryXAxis Title-Text="Periodo" LabelRotation="90" HidePartialLabels="false" MaximumLabels="24" />
                    <PrimaryYAxis LabelFormat="$ {value}" Title-Text="" />
                    <Legend Visible="false" Position="Top" Font-FontSize="12px"
                        ItemStyle-Height="12" ItemStyle-Width="12"></Legend>
                    <CommonSeriesOptions Type="Line" DoughnutSize="0.2"
                        Tooltip-Format="#point.x# : $ #point.y#"
                        Tooltip-Visible="true"
                        Tooltip-Fill="#72bc49"
                        Tooltip-Border-Width="1"
                        Tooltip-Border-Color="#FFFFFF"
                        Tooltip-Font-Color="#FFFFFF"
                        Marker-Size-Height="10"
                        Marker-Size-Width="10"
                        Marker-Border-Width="2"
                        Marker-Visible="true"
                        EnableAnimation="True" />
                    <Series>
                        <ej:Series XName="nombre" YName="costoLabor" Name="Período" EnableAnimation="true" LabelPosition="Inside" Type="Line">
                            <Tooltip Visible="true" Format="#point.x# : $ #point.y#" EnableAnimation="true"></Tooltip>
                        </ej:Series>
                    </Series>
                </ej:Chart>
            </div>
        </div>
        <div class="row">
            <div class="col-xs-12 col-md-12 col-lg-12">
                <asp:Button ID="btn" Text="Grid" runat="server" />
            </div>
        </div>
    </div>


</asp:Content>

