﻿function notificar(modal, label, mensaje) {
    $(modal).modal('show');
    console.log(modal);
    console.log(label);
    document.getElementById(label).textContent = mensaje;
}

function validacionFormatoFecha(idCampoFecha, formato, modal, label) {
    var campoFecha = document.getElementById(idCampoFecha)

    //verifica en caso que no se halla digitado nada y se está usando la ayuda no se ejecute la validación
    if ((campoFecha.value == '') || (campoFecha.value == 'MM/DD/YYYY')) {
        campoFecha.focus();
        return false;
    }

    var dateformat = /^(0?[1-9]|1[012])[\/\-](0?[1-9]|[12][0-9]|3[01])[\/\-]\d{4}$/;
    // Match the date format through regular expression  
    if (campoFecha.value.match(dateformat)) {
        //campoFecha.focus();
        //Test which seperator is used '/' or '-'  
        var opera1 = campoFecha.value.split('/');
        var opera2 = campoFecha.value.split('-');
        lopera1 = opera1.length;
        lopera2 = opera2.length;
        // Extract the string into month, date and year  
        if (lopera1 > 1) {
            var pdate = campoFecha.value.split('/');
        }
        else if (lopera2 > 1) {
            var pdate = campoFecha.value.split('-');
        }

        if ((formato == 'mm/dd/yyyy') || (formato == 'mm-dd-yyyy') || (formato == 'MM-dd-yyyy') || (formato == 'MM/dd/yyyy')) {
            var mm = parseInt(pdate[0]);
            var dd = parseInt(pdate[1]);
            var yy = parseInt(pdate[2]);
        } else if ((formato == 'dd/mm/yyyy') || (formato == 'dd-mm-yyyy')) {
            var dd = parseInt(pdate[0]);
            var mm = parseInt(pdate[1]);
            var yy = parseInt(pdate[2]);
        } else {
            notificar(modal, label, 'El formato de fecha: ' + formato + ' es inválido o no ha sido definida su validación')
            //notificarFallaValidacion(campoFecha, 'El formato de fecha: ' + formato + ' es inválido o no ha sido definida su validación', '');
            return false;
        }

        // Create list of days of a month [assume there is no leap year by default]  
        var ListofDays = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
        if (mm == 1 || mm > 2) {
            if (dd > ListofDays[mm - 1]) {
                notificar(modal, label, 'Formato de fecha no válido')
                //notificarFallaValidacion(campoFecha, 'Formato de fecha no válido', '');
                return false;
            }
        }
        if (mm == 2) {
            var lyear = false;
            if ((!(yy % 4) && yy % 100) || !(yy % 400)) {
                lyear = true;
            }
            if ((lyear == false) && (dd >= 29)) {
                notificar(modal, label, 'Formato de fecha no válido')
                //notificarFallaValidacion(campoFecha, 'Formato de fecha no válido', '');
                return false;
            }
            if ((lyear == true) && (dd > 29)) {
                notificar(modal, label, 'Formato de fecha no válido')
                //notificarFallaValidacion(campoFecha, 'Formato de fecha no válido', '');
                return false;
            }
        }
    }
    else {
        notificar(modal, label, 'Formato de fecha no válido')
        //notificarFallaValidacion(campoFecha, 'Formato de fecha no válido', '');
        return false;
    }
}

function esNumerico(expression) {
    return (String(expression).search(/^\d+$/) != -1);
}

function validarNumero(valor, idCampo, modal, label) {
    if (esNumerico(valor) == false) {
        idCampo.value = "";
        notificar(modal, label, 'El valor debe ser numérico')
    }
}

function mostrarMensajeDiv(nombreDiv, campo, valor) {
    if (valor == 0) {
        $("#" + nombreDiv).slideToggle("slow").text(campo);
        $("#" + nombreDiv).delay(5000).hide('slow');
        $("#" + nombreDiv).attr("class", "alert fade in alert-danger");
    } else if (valor == 1) {
        $("#" + nombreDiv).slideToggle("slow").text(campo);
        $("#" + nombreDiv).delay(5000).hide('slow');
        $("#" + nombreDiv).attr("class", "alert fade in alert-success");
    } else if (valor == 2) {
        $("#" + nombreDiv).slideToggle("slow").text(campo);
        $("#" + nombreDiv).delay(5000).hide('slow');
        $("#" + nombreDiv).attr("class", "alert fade in alert-warning");
    }
}