﻿function obtenerNombrePorCodigo(idOrigen, idDestino, lista) {
    var campo1 = document.getElementById(idOrigen)
    var campo2 = document.getElementById(idDestino)

    for (var i = 0; i < lista.length; i++) {
        if (campo1.value == lista[i].CODIGO) {
            campo2.value = lista[i].NOMBRE;
            return;
        }
    }
    notificarFallaValidacion(campo1, 'Código no encontrado', '');
    campo1.value = '';
    campo2.value = '';
    return false;
}

function validarCargadorRepetido(idOrigen,idDestino, lista) {
    var campo1 = document.getElementById(idOrigen)
    var campo2 = document.getElementById(idDestino)
    var empleadoRepetido = false;
    console.log("entro cargador rep");
    for (var i = 0; i < lista.length; i++) {
        if (campo1.value.trim() == lista[i].Empleado_CarRem.trim()) {
            empleadoRepetido = true
            break;
        }
    }

    if (empleadoRepetido == true) {
        campo2.value = ''// limpia el campo descripción
        notificarFallaValidacion(campo1, 'El cargador ya se encuentra asociado a esta remisión', '');
        return false;
    }
    
}

function pesoValido(idPeso) {
    var campo1 = document.getElementById(idPeso);
    if (isNumeric(campo1.value)) {
        return;
    } else {
        notificarFallaValidacion(campo1, 'El peso debe ser un valor numérico', '');
    }
}

function placaMayuscula(idPlaca) {
    var campo1 = document.getElementById(idPlaca);
    campo1.value = campo1.value.toUpperCase();
}

function totalValido(idTotal, idCodigoEmpleado) {
    var campoTotal = document.getElementById(idTotal);
    var campoCodigoEmpleado = document.getElementById(idCodigoEmpleado);
    if (isNumeric(campoTotal.value) && campoTotal.value > 0) {
        campoCodigoEmpleado.focus();
        return;
    } else {
        notificarFallaValidacion(campoTotal, 'El total debe ser un valor numérico', '');
    }
}

function validarLote(idLote, idTotal, idTipo, lista) {
    var campoLote = document.getElementById(idLote);
    var campoTotal = document.getElementById(idTotal);
    var campoTipo = document.getElementById(idTipo);
    for (var i = 0; i < lista.length; i++) {
        console.log(lista[0].CODIGO);
        if (campoLote.value.toUpperCase() == lista[i].CODIGO) {
            campoLote.value = campoLote.value.toUpperCase();
            campoTotal.focus();
            var radio = campoTipo.getElementsByTagName("input");
            radio[0].checked = true;
            return;
        }
    }
    notificarFallaValidacion(campoLote, "El Lote: " + campoLote.value + " no se encuentra registrado en la base de datos o se encuentra inactivo", '');
    return false;
}
